//
//  Parcel.swift
//  RWPS
//
//  Created by Mic Pringle on 04/12/2014.
//  Copyright (c) 2014 Razeware LLC. All rights reserved.
//

import UIKit
import CoreData

@objc(Parcel)
class Parcel: NSManagedObject {

  @NSManaged var supplierName: String
  @NSManaged var orderNo: String
  @NSManaged var orderDate: NSDate
  @NSManaged var deliveryDate: NSDate
  @NSManaged var latitude: NSNumber
  @NSManaged var longitude: NSNumber
  @NSManaged var status: String
  @NSManaged var supplierBrandColor: UIColor
  @NSManaged var supplierAlternateBrandColor: UIColor
  @NSManaged var itemName: String
  @NSManaged var location: String
  
  func daysRemainingBeforeDelivery() -> Int {
    let calendar = NSCalendar.currentCalendar()
    var fromDate: NSDate? = nil
    var toDate: NSDate? = nil
    var interval: NSTimeInterval = 0
    calendar.rangeOfUnit(NSCalendarUnit.CalendarUnitDay, startDate: &fromDate, interval: &interval, forDate: NSDate())
    calendar.rangeOfUnit(NSCalendarUnit.CalendarUnitDay, startDate: &toDate, interval: &interval, forDate: deliveryDate)
    let difference: NSDateComponents = calendar.components(NSCalendarUnit.CalendarUnitDay, fromDate: fromDate!, toDate: toDate!, options: nil)
    return max(0, difference.day)
  }
  
  func deliveryDateForUseWithTimer() -> NSDate? {
    let calendar = NSCalendar.currentCalendar()
    let components = calendar.components(.CalendarUnitHour | .CalendarUnitMinute | .CalendarUnitSecond, fromDate: NSDate())
    let adjustedDeliveryDate = calendar.dateByAddingComponents(components, toDate: deliveryDate, options: nil)?.dateByAddingTimeInterval(60)
    return adjustedDeliveryDate
  }
  
}